### data_epilepsy ###
# variables
# (1) y : The seizure counts during 2-week periods before each of four visits to the clinic.
# (2) T : Treatment(0=new drug, 1=placebo).
# (3) B : The average number of epileptic seizures in the 8-week period preceding the trial.
# (4) A : The logarithm of age in years of each patient.
# (5) V : Linear trend coded (-3, -1, 1, 3)/10 for four visits of each patient.
# (6) patient : Patient number for 59 epileptics.
# (7) id : Observation number for 236 observations.

#### NB HGLM ###
model_mu<-DHGLMMODELING(Model="mean", Link="log", LinPred=y~B+T+A+T*B+V+(1|patient)+(1|id),RandDist=c("gaussian","gamma"))
model_phi<-DHGLMMODELING(Model="dispersion")
res_hglm1<-dhglmfit(RespDist="poisson",DataMain=data_epilepsy,MeanModel=model_mu,DispersionModel=model_phi)


#### Poisson HGLM ###
model_mu<-DHGLMMODELING(Model="mean", Link="log", LinPred=y~B+T+A+T*B+V+(1|patient)+(1|id),RandDist=c("gaussian","gaussian"))
model_phi<-DHGLMMODELING(Model="dispersion")
res_hglm2<-dhglmfit(RespDist="poisson",DataMain=data_epilepsy,MeanModel=model_mu,DispersionModel=model_phi)


#### NB DHGLM  ###
model_mu<-DHGLMMODELING(Model="mean", Link="log", LinPred=y~B+T+A+T*B+V+(1|patient)+(1|id),RandDist=c("gaussian","gamma"),
         LinkRandVariance="log",LinPredRandVariance=c(lambda~1+(1|patient),lambda~1),RandDistRandVaraince="inverse-gamma")
model_phi<-DHGLMMODELING(Model="dispersion")
res_dhglm1<-dhglmfit(RespDist="poisson",DataMain=data_epilepsy,MeanModel=model_mu,DispersionModel=model_phi)


#### Poisson DHGLM  ###
model_mu<-DHGLMMODELING(Model="mean", Link="log", LinPred=y~B+T+A+T*B+V+(1|patient)+(1|id),RandDist=c("gaussian","gaussian"),
         LinkRandVariance="log",LinPredRandVariance=c(lambda~1+(1|patient),lambda~1),RandDistRandVaraince="inverse-gamma")
model_phi<-DHGLMMODELING(Model="dispersion")
res_dhglm2<-dhglmfit(RespDist="poisson",DataMain=data_epilepsy,MeanModel=model_mu,DispersionModel=model_phi)
